/**
 * Created by Marcelo Barros (marcelobjr@gmail.com).
 */

angular.module('<%= moduleName %>')
    .factory('<%= moduleName %>Services',["$http","$q","appConfig",function ($http,$q,appConfig) {
        return {
            retrieve<%= moduleName %>s:function(){

                var defer=$q.defer();
                $http.get(appConfig.baseUrl +"/<%= moduleVariable %>")
                    .success(function(result){defer.resolve(result)})
                    .error(function(error){defer.reject(error)});
                return defer.promise;
            },
            save<%= moduleName %>:function(<%= moduleName %>Obj){

                var defer=$q.defer();
                $http.post(appConfig.baseUrl +"/<%= moduleVariable %>",<%= moduleName %>Obj)
                    .success(function(result){defer.resolve(result)})
                    .error(function(error){defer.reject(error)});
                return defer.promise;
            },
            update<%= moduleName %>:function(<%= moduleName %>Obj){

                var defer=$q.defer();
                $http.put(appConfig.baseUrl +"/<%= moduleVariable %>/"+<%= moduleName %>Obj.id,<%= moduleName %>Obj)
                    .success(function(result){defer.resolve(result)})
                    .error(function(error){defer.reject(error)});

                return defer.promise;
            },
            delete<%= moduleName %>:function(id){

                var defer=$q.defer();
                $http.delete(appConfig.baseUrl +"/<%= moduleVariable %>/"+id)
                    .success(function(result){defer.resolve(result)})
                    .error(function(error){defer.reject(error)});

                return defer.promise;
            },
            retrieve<%= moduleName %>ById:function(id){

                var defer=$q.defer();
                $http.get(appConfig.baseUrl +"/<%= moduleVariable %>/"+id)
                    .success(function(result){defer.resolve(result)})
                    .error(function(error){defer.reject(error)});
                return defer.promise;
            }
        }
    }]);